<?php
namespace Folha\Repositories;

class FpaTipoincide extends \Doctrine\ORM\EntityRepository
{

    /**
     * Função retorna uma lista com todos os tipos de incidência do evento concatenados com um ID para identificar se é
     * uma base de cálculo 'B' ou se é um evento que recebe o valor total 'T', todos separados por um '_'.
     *
     * @param $nrEventom
     * @param $nrorg
     * @return string
     */
    public static function retornaTipoIncideEvento($nrEventom, $nrorg)
    {
        $listaTipoincide = "_";

        $sqlBase = <<<SQL
SELECT DISTINCT TI.NRTIPOINCIDE||'B' TIPOINCIDE
  FROM FPA_TIPOINCIDE TI
 WHERE (TI.NRORG = 0 OR TI.NRORG = $nrorg OR TI.NRORG IS NULL)
   AND TI.NREVENBASE = $nrEventom
SQL;
        $listBase = \Setforms2\Shared\Connection::getInstance()->fetchAll($sqlBase);

        foreach ($listBase as &$row) {
            $listaTipoincide = $listaTipoincide.$row['TIPOINCIDE']."_";
        }

        $sqlTotal = <<<SQL
SELECT DISTINCT TI.NRTIPOINCIDE||'T' TIPOINCIDE
  FROM FPA_TIPOINCIDE TI
 WHERE (TI.NRORG = 0 OR TI.NRORG = $nrorg OR TI.NRORG IS NULL)
   AND TI.NREVENRETORN = $nrEventom
SQL;
        $listTotal = \Setforms2\Shared\Connection::getInstance()->fetchAll($sqlTotal);

        foreach ($listTotal as &$row) {
            $listaTipoincide = $listaTipoincide.$row['TIPOINCIDE']."_";
        }

        return $listaTipoincide;
    }
}